#ifndef __IMP2C_H_
#define __IMP2C_H_ 1

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

#define nl '\n'
#define tab '\t'
#define esc '\e'

extern int instream, outstream;
extern FILE *in[4], *out[4];
#define infile (in[instream])
#define outfile (out[outstream])

void safe_sprintf(char *dest, char *format, ...);
void safe_strcpy(char *dest, char *src);
void safe_strncpy(char *dest, char *src, int length);
void imp_init(int argc, char **argv);
char *imp_inputname(void);
int qualifierpresent(char *key);
void printidentification(void);
char *qualifiers(char *key);
void spawncommand(char *s, ...);
void prompt(char *s);
char *imp_date(void);
char *imp_time(void);
float stor(char *str);
int readline(char *s, int maxsize);
void read_string(char *s);
void read_int(int *i);
void readsymbol(int *sym);
int nextsymbol(void);
void skipsymbol(void);
void space(void);
void spaces(int count);
void imp_tolower(char *s);
void imp_toupper(char *s);
int openbinaryinput(int stream, char *s);
int openbinaryoutput(int stream, char *s);
int openinput(int stream, char *s);
int openoutput(int stream, char *s);
void resetinput(void);
void closeinput(void);
void closeoutput(void);
void selectinput(int stream);
void selectoutput(int stream);
void warningmessage(char *s, ...);
void fatalerror(char *s, ...);
char *substring (char *str, int low, int high);
char *translate(char *key);
#endif
