#include "imp2c.h"

#include "jb_patts.h"
#ifdef NEVER
void parsejobdeck ( /*... */ );
void scanjobdeckpatterns ( /*... */ );
void setfromoption ( /*... */ );
void setvariandirectory ( /*... */ );

#define getcustomerpatterns 1
#define getallpatterns 2
#define checkmissinglist 3
#define outputmissinglist 4
#define outputextralist 5
#define outputorbotlist 6
#define dumpdatastructure 7
#define maxmode 7

#define nofrommode 0
#define optimisemode 1
#define copymode 2
#define renamemode 3
const char zippedextension[3 + 1] = "-GZ";

#define maxlayers 320
#define true 1
#define false 0
#endif

const int localfile = 1;
const int standardfile = 2;
const int neededfile = 3;
const int missingfile = 4;
#define maxsource 4
const char *sources[maxsource + 1] = {
  "",
  "Local   ",
  "Standard",
  "Needed  ",
  "Missing "
};
#define sources(n) sources[n]

const int usedfile = 1;
const int unusedfile = 2;
#define maxstatus 2
const char *status[maxstatus + 1] = {
  "", "   Used", "Un-used"
};
#define status(n) status[n]

const int unknown = -1;
const int all = 0;

typedef struct chipfm
{
  int source, status, layer;
  char name[15 + 1];
  struct chipfm *next;
} chipfm;

static chipfm templatechip;

#define firstchip 33
#define lastchip 127
chipfm *chips[lastchip - firstchip + 1];
#define chips(n) chips[(n)-firstchip]

static char customercode[3 + 1] = "";
static int frommode = optimisemode;
static int debug = false;
static char stddirectory[31 + 1] = "/cgi/stdjob/";
static char stdhead[31 + 1] = "/cgi/stdjob/";
static char destdirectory[255 + 1] = "./";
static char copy[7 + 1] = "cp ";
static char rename_[7 + 1] = "mv ";
static char filespec[15 + 1] = "*";
static char unixtempfile[255 + 1] = ".get_dir.txt";
static char filename[255 + 1] = "";
static char fromdirectory[255 + 1] = "";
static char lastfromdirectory[255 + 1] = "";
#define maxreadme 24
static int numreadmes = 0;
static char readmes[maxreadme + 1][127 + 1];
#define readmes(n) readmes[n]

static char tmp[255 + 1];

void
addtodatastructure (int source, int layer, char *name)
{
  chipfm *chip, *newchip;
  int i;
  chip = chips (name[(1) - 1]);
  while (chip != NULL)
    {
      if (strcmp (chip->name, name) == 0)
	{
	  if (chip->layer < 0)
	    chip->layer = layer;
	  if (chip->source != localfile)
	    chip->source = source;
	  chip->status = usedfile;
	  return;
	}
      chip = chip->next;
    }
  newchip = calloc (1, sizeof (templatechip));
  newchip->source = source;
  newchip->layer = layer;
  strcpy (newchip->name, name);
  if (source == localfile)
    {
      newchip->status = unusedfile;
    }
  else
    {
      newchip->status = usedfile;
    }
  newchip->next = chips (name[(1) - 1]);
  chips[name[(1) - 1]] = newchip;
}

void
checkforreadme (char *dir)
{
#define maxolddir 10
  static char olddirs[maxolddir + 1][255 + 1];
#define olddirs(n) olddirs[n]
  static int numolddir = 0;
  int i;
  for (i = 1; i <= numolddir; i += 1)
    {
      if (olddirs (i) == dir)
	return;
    }
  sprintf (tmp, "%sREAD.ME", dir);
  if (!openinput (3, tmp))
    return;
  selectinput (3);
  closeinput ();
  if (numolddir < maxolddir)
    numolddir += 1;
  strcpy (olddirs[numolddir], dir);
  numreadmes += 1;
  if (numreadmes <= maxreadme)
    strcpy (readmes[numreadmes], dir);
}

void
printreadmes ()
{
  int i;
  for (i = 1; i <= numreadmes; i += 1)
    {
      warningmessage ("\e[1mPlease read the file %sREAD.ME\e[0m",
		      readmes (i));
    }
}

void
getfiles (int mode, int layer, char *directory)
{
  int c, sym, numfiles, instr = instream;
  char line[255 + 1];
  char chipname[15 + 1];
  char file[255 + 1];
  char defnam[255 + 1];
  char es[255 + 1];
  char rs[255 + 1];
  int status;
  char *p;

  numfiles = 0;
  sprintf(line, "ls -1 %s > %s", directory, unixtempfile);
  spawncommand (line);
  if (!openinput (2, ".get_dir.txt")) {
      if (debug == false)
	spawncommand ("rm %s", unixtempfile);
      return;
    }
  selectinput (2);
  for (;;)
    {
      readline (rs, sizeof(rs));
      if ((p=strchr(rs, '/')) != NULL)
	{
          strcpy(chipname, p+1);
	}
      imp_toupper (chipname);
      if (strlen (chipname) != 12 || chipname[(10) - 1] != '.')
	continue;
      if (mode == localfile)
	{
	  if (!(strstr (chipname, (".JB"))))
	    addtodatastructure (mode, layer, chipname);
	}
      else
	{
	  sprintf(line, "%s%s %s", copy, rs, destdirectory);
	  spawncommand (line);
	  addtodatastructure (localfile, layer, chipname);
	  checkforreadme (lastfromdirectory);
	  selectinput (instr);
	  return;
	}
    }
}
void
setfromoption (int fmode, char *directory)
{
  frommode = fmode;
  strcpy(fromdirectory, directory);
  if (directory[(strlen (directory)) - 1] != '/')
    sprintf(fromdirectory, "%s/", directory);
}

void
parsejobdeck (int *wanted, int stream)
{
  int layer;
  int sym;
  int group;
  char line[255 + 1];
  char layerbit[255 + 1];
  char name[15 + 1];
  char *p;

//  if (setjmp ())
//    {
//      fatalerror ("No END command found in the job deck file");
//    }

  selectinput (stream);
  strcpy(line, imp_inputname());
  // %if Line -> Dest Directory.("]").Line %start
  if ((p=strchr(line, ']')) != NULL)
    {
      strncpy(destdirectory, line, p-line);
      safe_strcpy(line, p+1);
      strcat (destdirectory, "]");
    }
  if ((p=strchr(line, '/')) != NULL)
    {
      strncpy(destdirectory, line, p-line);
      safe_strcpy(line, p+1);
      strcat (destdirectory, "/");
    }
  sprintf(tmp, "%s%s", destdirectory, filespec);
  getfiles (localfile, unknown, tmp);
  selectinput (stream);
  strcpy (customercode, "");
  if (strlen (line) > 3)
    strcpy(customercode, substring (line, 1, 3));
  strcpy (lastfromdirectory, "");
  for (;;)
    {
      while (nextsymbol() <= ' ')
	skipsymbol ();
      do
	{
	  read_string (line);
	}
      while (!(strcmp (line, "")));
      if (line[(1) - 1] == '*')
	{
	  do
	    {
	      readsymbol (&sym);
	    }
	  while (!(sym == nl));
	  continue;
	}
      else if ((strcmp (line, "CHIP") == 0))
	{
	  do
	    {
	      readsymbol (&sym);
	    }
	  while (!(sym == ','));
	  for (;;)
	    {
	      readsymbol (&sym);
	      if (sym == '*')
		{
		  do
		    {
		      readsymbol (&sym);
		    }
		  while (!(sym == nl));
		}
	      else if (sym == '(')
		{
		  while (nextsymbol() <= ' ')
		    skipsymbol ();
		  if (nextsymbol() == 'A')
		    layer = 0;
		  else
		    read_int (&layer);
		  do
		    {
		      readsymbol (&sym);
		    }
		  while (!(sym == ','));
		  while (nextsymbol() <= ' ')
		    skipsymbol ();
		  strcpy (name, "");
		  for (;;)
		    {
		      readsymbol (&sym);
		      if (sym == ',')
			{
			  do
			    {
			      readsymbol (&sym);
			    }
			  while (!(sym == ')'));
			}
		      if (sym == ')')
			break;
		      if (sym == '-')
			{
			  if (strlen (name) == 9)
			    strcat (name, ".");
			}
		      else if (sym == '<')
			{
			  do
			    {
			      readsymbol (&sym);
			    }
			  while (!(sym == '>'));
			}
		      else
			{
			  safe_sprintf (name, "%s%c", name, sym);
			}
		    }
		  if (strlen (name) != 12)
		    {
		      warningmessage ("Bad format of pattern name: %s", name);
		    }
		  if (wanted[all] == false && 1 <= layer
		      && layer <= maxlayers && wanted[layer] != true)
		    {
		      continue;
		    }
		  addtodatastructure (neededfile, layer, name);
		}
	      else if (sym == 'R')
		{
		  readline (line, sizeof(line));
		  break;
		}
	    }
	}
      else if (strlen (line) >= 3
	       && (strcmp (substring (line, 1, 3), "END") == 0))
	{
	  break;
	}
      else if (strlen (line) >= 5
	       && (strcmp (substring (line, 1, 5), "GROUP") == 0))
	{
	  readline (line, sizeof(line));
	  if ((p=strchr(line, '*')) != NULL)
	    {
              safe_strcpy(line, p+1);
	    }
	  {
//	    if (setjmp ())
//	      {
//		fatalerror ("Problem extracting GROUP info from : %s", line);
//	      }
	    if (!((p=strchr(line, ',')) != NULL))
	      {
		warningmessage ("Bad format of GROUP command: %s", line);
		return;
	      }
            else
              {
                strncpy(layerbit, line, p-line);
                safe_strcpy(line, p+1);
              }
	    layer = atoi (layerbit);
	    strcat (line, ",");

            // %while Line -> Layer bit.(",").Line %cycle
	    while ((p=strchr(line, ',')) != NULL)
	      {
                strncpy(layerbit, line, p-line);
                safe_strcpy(line, p+1);
		group = atoi (layerbit);
		wanted[group] = wanted[layer];
	      }
	  }
	}
      else
	{
	}
    }
}
void
scanjobdeckpatterns (int mode, 
                     int *numfiles,
                     int *missingcount,
                     int *extracount,
                     int *zippedflag)
{
  
  chipfm *chip;
  int i;
  static char line[255 + 1];

  *numfiles = 0;
  *missingcount = 0;
  *extracount = 0;

  for (i = firstchip; i <= lastchip; i += 1)
    {
      if (chips (i) != NULL)
	{
	  chip = chips (i);
	  while (chip != NULL)
	    {
	      switch (mode)
		{
		case getcustomerpatterns:	/* getcustomerpatterns */
		case getallpatterns:	/* getallpatterns */
		  *numfiles += 1;
		  if (chip->status == usedfile)
		    {
		      if (chip->source == neededfile)
			{
			  {
//			    if (setjmp ())
//			      {
//				return;
//			      }
			    if ((strcmp (chip->name, "DUMMYFILE.00") == 0))
			      {
				sprintf (line, "%s%sDUMMYFILE.00 %s",
					 copy, stddirectory, destdirectory);
				imp_tolower (line);
				spawncommand (line);
				chip->source = localfile;
			      }
			    else
			      {
				sprintf (line, "%s%s", stddirectory,
					 chip->name);
				imp_tolower (line);
				openbinaryinput (3, line);
				selectinput (3);
				closeinput ();
				chip->source = standardfile;
				if (mode == getallpatterns)
				  {
				    sprintf (line, "%s%s%s %s", copy,
					     stddirectory, chip->name,
					     destdirectory);
				    imp_tolower (line);
				    spawncommand (line);
				    chip->source = localfile;
				  }
			      }
			  }
			}
		      if (chip->source == neededfile
			  && strcmp (fromdirectory, ""))
			{
			  {
			    char ext[7 + 1] = "";

// TODO: improve the code below

//			    if (setjmp ())
//			      {
//				if (strcmp (ext, ""))
//				  {
//				    return;
//				  }
//				else
//				  {
//				    strcpy(ext, zippedextension);
//				  }
//			      }
			    sprintf (filename, "%s%s%s", fromdirectory,
				     chip->name, ext);
			    imp_tolower (filename);
			    (void)openbinaryinput (3, filename);
			    selectinput (3);
			    closeinput ();
			    if (frommode == renamemode)
			      {
				strcpy(line, rename_);
			      }
			    else
			      {
				strcpy(line, copy);
			      }
			    strcat (line, filename);
			    strcat (line, " ");
			    strcat (line, destdirectory);
			    spawncommand (line);
			    if (strcmp(ext, zippedextension) == 0)
			      *zippedflag = true;
			    chip->source = localfile;
			  }
			}
		      if (chip->source == neededfile
			  && frommode == optimisemode)
			{
			  if (strcmp (lastfromdirectory, ""))
			    {
			      sprintf (tmp, "%s%s", lastfromdirectory,
				       chip->name);
			      getfiles (neededfile, chip->layer, tmp);
			    }
			  else
			    {
			      if ((strcmp (customercode, "MEK") == 0)
				  || (strcmp (customercode, "MSQ") == 0)
				  || (strcmp (customercode, "MOT") == 0))
				{
				  sprintf (fromdirectory, "%s%s.%s...]",
					   stdhead,
					   customercode,
					   substring (chip->name, 1, 4));
				}
			      else if ((strcmp (customercode, "STA") == 0))
				{
				  sprintf (fromdirectory, "%sSTA.%s*...]",
					   stdhead,
					   substring (chip->name, 1, 5));
				}
			      sprintf (tmp, "%s%s", fromdirectory,
				       chip->name);
			      getfiles (neededfile, chip->layer, tmp);
			      strcpy (fromdirectory, "");
			    }
			}
		      if (chip->source == neededfile)
			{
			  sprintf (tmp, "%s%s...]%s",
				   stdhead, customercode, chip->name);
			  getfiles (neededfile, chip->layer, tmp);
			  if (chip->source == neededfile)
			    {
			      *missingcount += 1;
			    }
			}
		    }
		  chip = chip->next;
		  continue;
		case checkmissinglist:	/* checkmissinglist */
		  *numfiles += 1;
		  if (chip->source == neededfile)
		    {
		      *missingcount += 1;
		    }
		  if (chip->source == localfile && chip->status == unusedfile)
		    {
		      *extracount += 1;
		    }
		  chip = chip->next;
		  continue;
		case outputmissinglist:	/* outputmissinglist */
		  *numfiles += 1;
		  if (chip->source == neededfile)
		    {
		      if (*missingcount == 0)
			{
			  fprintf (outfile,
				   "\e[1mThe following patterns are referenced by the job deck but could not be found:\e[0m\n");
			}
		      fprintf (outfile, "   %s first used on layer ",
			       chip->name);
		      if (chip->layer == 0)
			fprintf(outfile, "A");
		      else
			fprintf(outfile, "%0d", chip->layer);
		      *missingcount += 1;
		      if ((*missingcount & 1) == 0)
			fprintf (outfile, "n");
		    }
/* Pointer assignment */ chip = chip->next;
		  continue;
		case outputextralist:	/* outputextralist */
		  *numfiles += 1;
		  if (chip->source == localfile && chip->status == unusedfile)
		    {
		      if (*extracount == 0)
			{
			  fprintf (outfile,
				   "\e[1mThe following patterns are in the directory but not referenced by job deck:\e[0m\n");
			}
		      fprintf (outfile, "   %s", chip->name);
		      *extracount += 1;
		      if ((*extracount & 3) == 0)
			fprintf (outfile, "n");
		    }
		  chip = chip->next;
		  continue;
		case outputorbotlist:	/* outputorbotlist */
		  if (chip->source == localfile && chip->status == usedfile)
		    {
		      imp_tolower (chip->name);
		      fprintf (outfile, "put %s\n", chip->name);
		      *numfiles += 1;
		    }
		  chip = chip->next;
		  continue;
		case dumpdatastructure:	/* dumpdatastructure */
		  if (1 <= chip->source && chip->source <= maxsource)
		    {
		      fprintf (outfile, "%s ", sources (chip->source));
		    }
		  else
		    {
		      fprintf(outfile, "%7d ", chip->source);
		    }
		  if (1 <= chip->status && chip->status <= maxstatus)
		    {
		      fprintf (outfile, "%s ", status (chip->status));
		    }
		  else
		    {
		      fprintf(outfile, "%7d ", chip->status);
		    }
		  if (chip->layer < 0)
		    {
		      fprintf (outfile, "  ??");
		    }
		  else if (chip->layer == 0)
		    {
		      fprintf (outfile, " ALL");
		    }
		  else
		    {
		      fprintf(outfile, "%3d", chip->layer);
		    }
		  fprintf (outfile, "   %s", chip->name);
		  fprintf (outfile, "n");
		  chip = chip->next;
		}
	    }
	}
    }

  if (((mode == outputmissinglist) && ((*missingcount & 1) != 0))
      || ((mode == outputextralist) && ((*extracount & 3) != 0)))
    fprintf (outfile, "n");
  if (mode == getcustomerpatterns || mode == getallpatterns)
    printreadmes ();
}
