char version[31 + 1] = "2",
     release[31 + 1] = "26",
     revision[31 + 1] = "1",
     fname[31 + 1] = "JBGEN",
     productcode[31 + 1] = "JBGEN";

#include "imp2c.h"

int
main (int argc, char **argv)
{
#define vms 0
#define unix 1
static int target = unix;
#define maxlayers 320
#define true 1
#define false 0
  const float minresolution = 0.004;
  const int centers['8'-'3'+1] = { 38100, 50800, 63500, 76200, 88900, 88900 };
#define centers(n) centers[(n)-'3']
  const short slidecodes['8'-'3'+1] = { 10, 13, 14, 17, 19, 22 };
#define slidecodes(n) slidecodes[(n)-'3']
  static char dclline[255 + 1];
  static int intreticlescale = 0;
  static int mebesjb = false;
  static int baetitles = false;
  static int copy3inch = false;
  static int master3inch = false;
  static char commandline[255 + 1];
  char outname[255 + 1];
  char line[255 + 1];
  char a[255 + 1];
  char b[255 + 1];
  char str[255 + 1];
  char operator[15 + 1];
  char sonumber[7 + 1];
  int masksize;
  int nummasks;
  int datasense;
  int titlesense;
  int i;
  int response;
  float globalresolution;
  char dtitleline[63 + 1];

// these arrays are one larger in C than in imp - we preserve the
// imp array 1:maxlayers by creating a C version 0:maxlayers+1
// which is one larger but allows us to retain the original indices
  char titles[maxlayers+1][63 + 1];
#define titles(n) titles[n]
  char title1[maxlayers+1][63 + 1];
#define title1(n) title1[n]
  char title2[maxlayers+1][63 + 1];
#define title2(n) title2[n]
  char titlename[maxlayers+1][15 + 1];
#define titlename(n) titlename[n]
  char chipname[maxlayers+1][15 + 1];
#define chipname(n) chipname[n]
  float resolutions[maxlayers+1];
#define resolutions(n) resolutions[n]
  int reverses[maxlayers+1];
#define reverses(n) reverses[n]

  char *tzdrtos (float r, int b, int a)
  {
    char format[256];
    char temp[255 + 1];

    sprintf(format, "%c%0d.%0df", '%', b, a);
    sprintf(temp, format, r);
    return (strdup(temp));
  }

  void generateklamarks (void)
  {
    if (!(qualifierpresent ("NOKLA")))
      {
	fprintf (outfile, "CHIP ");
	if (mebesjb == 'L')
	  fprintf (outfile, "<boj>");
	fprintf (outfile, "KLAM,\n");
      }
    switch (masksize)
      {
      case '3':		/* '3' */
	if (mebesjb != 'M')
	  {
	    fatalerror ("This plate size is not supported for this machine");
	  }
	fprintf (outfile, "$ (A,CGI3REF-00-0B,AD=0.5,SF=1.00)\n");
	fprintf (outfile, "ROWS 38100/38100\n");
	break;
      case '4':		/* '4' */
	if (mebesjb == '5')
	  {
	    fatalerror ("This plate size is not supported for this machine");
	  }
	fprintf (outfile, "$ (A,CGI4REF-00-0C,AD=0.5,SF=1.00)\n");
	fprintf (outfile, "ROWS 50800/50800\n");
	if (copy3inch == true)
	  {
	    fprintf (outfile, "*\n");
	    fprintf (outfile, "* 4 INCH MASTER FOR 3 INCH COPY - USE BOTH REF MARKS\n");
	    fprintf (outfile, "*\n");
	    fprintf (outfile, "CHIP KLA3,\n");
	    fprintf (outfile, "$ (A,CGI3REF-00-0B,AD=0.5,SF=1.00)\n");
	    fprintf (outfile, "ROWS 50800/50800\n");
	  }
	if (master3inch == true)
	  {
	    fprintf (outfile, "*\n");
	    fprintf (outfile, "* 4 INCH MASTER TOO BE CUT TO 3 INCH\n");//TO
	    fprintf (outfile, "*\n");
	    fprintf (outfile, "CHIP KLA3,\n");
	    fprintf (outfile, "$ (A,CGI3006-FR-05,AD=0.5,SF=1.00)\n");
	    fprintf (outfile, "ROWS 50800/50800\n");
	  }
	break;
      case '5':		/* '5' */
	if (qualifierpresent ("NOKLAM"))
	  {
	    fprintf (outfile, "$ (A,CGI5REF-CM-0A,AD=0.5,SF=1.00)");
	  }
	else
	  {
	    if (mebesjb == 'M')
	      {
		fprintf (outfile, "$ (A,CGI5REF-00-0C,AD=0.5,SF=1.00)");
	      }
	    else
	      {
		fprintf (outfile, "$ (A,CGI5REF-00-0D,AD=0.25,SF=1.00)");
	      }
	  }

	fprintf (outfile, "\nROWS 63500/63500\n");
	break;
      case '6':		/* '6' */
	if (qualifierpresent ("NOKLAM"))
	  {
	    fprintf (outfile, "$ (A,CGI6REF-CM-0A,AD=0.5,SF=1.00)");
	  }
	else
	  {
	    if (mebesjb == 'M')
	      {
		fprintf (outfile, "$ (A,CGI6REF-00-0D,AD=0.5,SF=1.00)");
	      }
	    else
	      {
		fprintf (outfile, "$ (A,CGI6REF-00-0E,AD=0.25,SF=1.00)");
	      }
	  }

	fprintf (outfile, "\nROWS 76200/76200\n");
	break;
      case '7':		/* '7' */
	if (mebesjb == '5')
	  {
	    fatalerror ("This plate size is not supported for this machine");
	  }
	if (!(qualifierpresent ("NOKLAM")))
	  {
	    fprintf (outfile, "$ (AR,KLAMARK-00-0C,AD=0.5,SF=1.00)\n");
	    fprintf (outfile, "ROWS 15000,2,147800/15000,2,147800\n");
	    fprintf (outfile, "*\n");
	  }
	fprintf (outfile, "CHIP ");
	if (mebesjb == 'L')
	  fprintf (outfile, "<boj>");
	fprintf (outfile, "CGI7REF,\n");
	fprintf (outfile, "$ (A,CGI7REF-CM-0A,AD=0.5,SF=1.00)\n");
	fprintf (outfile, "ROWS 88900/88900\n");
	break;
      case '8':		/* '8' */
	if (!(qualifierpresent ("NOKLAM")))
	  {
	    fprintf (outfile, "$ (AR,KLAMARK-00-0C,AD=0.5,SF=1.00)\n");
	    fprintf (outfile, "ROWS 20000,2,137800/35000,2,107800\n");
	    fprintf (outfile, "*\n");
	  }
	fprintf (outfile, "CHIP ");
	if (mebesjb == 'L')
	  fprintf (outfile, "<boj>");
	fprintf (outfile, "CGI7REF,\n");
	fprintf (outfile, "$ (A,CGI7REF-CM-0A,AD=0.5,SF=1.00)\n");
	fprintf (outfile, "ROWS 88900/88900\n");
	break;
      }

    fprintf (outfile, "*\n");
  }

// START OF PROGRAM

  imp_init(argc, argv);

  if (qualifierpresent ("IDENTIFY"))
    {
      printidentification ();
      if (!(qualifierpresent ("OUTPUT")))
	return(1);
    }
  if (qualifierpresent ("MEBES"))
    mebesjb = 'M';
  if (qualifierpresent ("ALTA"))
    mebesjb = 'L';
  if (qualifierpresent ("CORE"))
    mebesjb = 'L';
  if (qualifierpresent ("LASER"))
    mebesjb = 'L';
  if (qualifierpresent ("5500"))
    mebesjb = '5';
  if (qualifierpresent ("GMIR"))
    baetitles = true;
  if (qualifierpresent ("3COPY"))
    copy3inch = true;
  if (qualifierpresent ("3MASTER"))
    master3inch = true;
  if (baetitles == true)
    {
    }
  else
    {
      if (target == vms)
	{
	  strcpy(outname, qualifiers ("OUTPUT"));
	}
      else
	{
	  strcpy(outname, qualifiers ("FILES"));
	}
      if ((strcmp (outname, "") == 0))
	{
	  prompt ("Output Job Deck Name: ");
	  readline (outname, sizeof (outname));
	}
    }

  prompt ("SO Number:     ");
  readline (sonumber, sizeof (sonumber));
  imp_tolower (sonumber);
  if (baetitles == true)
    {
      sprintf(outname, "gmi%s.jb", sonumber);
      mebesjb = 'L';
      fprintf (outfile, "Enter mask size of 3\" for any 4\" masters going to 3\" copies\n");
    }
  prompt ("Operator: ");
  readline (operator, sizeof (operator));
  imp_toupper (operator);
  if (mebesjb == false)
    {
      prompt ("Machine (5500 or LASER or MEBES): ");
      for (;;)
	{
	  readsymbol (&mebesjb);
	  if ('a' <= mebesjb && mebesjb <= 'z')
	    mebesjb = mebesjb & 95;
	  if (mebesjb == 'M' || mebesjb == 'A' || mebesjb == 'C'
	      || mebesjb == '5' || mebesjb == 'L')
	    break;
	}
      while (nextsymbol() != nl)
	skipsymbol ();
      skipsymbol ();
      if (mebesjb == 'A' || mebesjb == 'C')
	mebesjb = 'L';
    }
  prompt ("Mask Size:     ");
  do
    {
      readsymbol (&masksize);
    }
  while (!
	 (masksize == '3' || masksize == '4' || masksize == '5'
	  || masksize == '6' || masksize == '7'));
  if (masksize == '7' && nextsymbol() == '.')
    masksize = '8';
  while (nextsymbol() != nl)
    skipsymbol ();
  skipsymbol ();
  if (baetitles == true)
    {
      if (masksize != '3' && masksize != '4')
	{
	  fatalerror
	    ("Unknown Mask size for GMIR (BAE) Product - must be 3 or 4");
	}
      if (masksize == '3')
	copy3inch = true;
      masksize = '4';
    }
  {
  int rc;
redonummasks:
  prompt ("Number of Masks: ");
  rc = fscanf(infile, "%d", &nummasks);
  while (nextsymbol() != nl)
    skipsymbol ();
  skipsymbol ();
  if ((rc != 1) || (!(1 <= nummasks && nummasks <= maxlayers)))
    {
      warningmessage ("Number of masks must be between 1 and 320");
      goto redonummasks;
    }
  }
  prompt ("Reading Sense of Data for E-beam Mask (I or C): ");
  do
    {
      {
	readsymbol (&datasense);
	datasense = datasense & 95;
      }
    }
  while (!(datasense == 'C' || datasense == 'I'));
  while (nextsymbol() != nl)
    skipsymbol ();
  skipsymbol ();
  prompt ("Reading Sense of Titles for E-beam Mask (I or C or N): ");
  do
    {
      {
	readsymbol (&titlesense);
	titlesense = titlesense & 95;
      }
    }
  while (!(titlesense == 'C' || titlesense == 'I' || titlesense == 'N'));
  while (nextsymbol() != nl)
    skipsymbol ();
  skipsymbol ();
  if (baetitles == true)
    {
      for (i = 1; i <= nummasks; i += 1)
	{
	  if (instream == 0) fprintf (stderr,
		   "Enter 2 char layer name layer %0d: ", i);
	  do
	    {
	      readline (line, sizeof (line));
	    }
	  while (!(strlen (line) == 2));
	  imp_toupper (line);
	  sprintf(titlename[i], "%s%s", sonumber, line);
	}
      for (i = 1; i <= nummasks; i += 1)
	{
	  if (instream == 0) fprintf(stderr,
		  "Enter 1st title for layer %0d: ", i);
	  readline (title1 (i), sizeof (title1 (i)));
	  imp_toupper (title1 (i));
	  if (instream == 0) fprintf(stderr,
		  "Enter 2nd title for layer %0d: ", i);
	  readline (title2 (i), sizeof(title2 (i)));
	  imp_toupper (title2 (i));
	}
      {
	int i;
	sprintf(line, "TIT%s.COM", sonumber);
	if (!openoutput (2, line))
	  {
	    fatalerror ("Unable to open output %s", line);
	  }
	selectoutput (2);
	for (i = 1; i <= nummasks; i += 1)
	  {
	    fprintf (outfile, "$ TITLE/LAYER=(1,2)/HEIGHT=1100 %s\n", titlename (i));
	    fprintf (outfile, "%s\n", title1 (i));
	    fprintf (outfile, "%s\n", title2 (i));
	    sprintf(titles[i], "%s  %s", title1 (i), title2 (i));
	  }
	closeoutput ();
	selectoutput (1);
	sprintf(commandline, "@%s", line);
	spawncommand (commandline);
      }
    }
  if (titlesense != 'N' && baetitles == false)
    {
      prompt ("D title for levels (e.g. Customer + Device):");
      readline (dtitleline, sizeof(dtitleline));
      imp_toupper (dtitleline);
      while (strlen (dtitleline) > 30)
	{
	  warningmessage ("DTITLE %s is too long, 30 chars max", dtitleline);
	  readline (dtitleline, sizeof(dtitleline));
	  imp_toupper (dtitleline);
	}
      for (i = 1; i <= nummasks; i += 1)
	{
	  if (instream == 0) fprintf (stderr, "M title for level%02d: ", i);
	  readline (titles (i), sizeof(titles (i)));
	  imp_toupper (titles (i));
	  while (strlen (titles (i)) > 30)
	    {
	      warningmessage ("MTITLE %s is too long, 30 chars max",
                              titles (i));
	      readline (titles (i), sizeof(titles (i)));
	      imp_toupper (titles (i));
	    }
	}
    }
  for (i = 1; i <= nummasks; i += 1)
    {
      char *s;
      if (outstream == 0) fprintf (stderr, "Chip file name for level%0d: ", i);
      readline (line, sizeof(line));
      imp_toupper (line);
      if ((s=strchr(line, ':')) != NULL)
	{
          memmove(line, s+1, strlen(s+1)+1);
	}
      if ((s=strchr(line, ']')) != NULL)
	{
          memmove(line, s+1, strlen(s+1)+1);
	}
      if ((s = strchr (line, ';')) != NULL)
	{
	  *s = '\0';
	}
      strcpy(chipname[i], line);
    }
  {
    reenter:
    prompt ("Enter Global resolution or 0 for individual prompts: ");
    int rc = fscanf(infile, "%f", &globalresolution);
    if (rc != 1) {
	warningmessage ("Invalid value for resolution - please re-enter it.");
	while (nextsymbol() != nl)
	  skipsymbol ();
      goto reenter;
    }
  }
  while (nextsymbol() != nl)
    skipsymbol ();
  skipsymbol ();
  for (i = 1; i <= nummasks; i += 1)
    {
      if (instream == 0)
        fprintf (stderr, "Reverse chip %s Y/N: ", chipname (i));
      do
	{
	  {
	    readsymbol (&response);
	    response &= 95;
	  }
	}
      while (!(response == 'Y' || response == 'N'));
      while (nextsymbol() != nl)
	skipsymbol ();
      skipsymbol ();
      if (response == 'Y')
	reverses[i] = true;
      else
	reverses[i] = false;
      if (!(globalresolution > minresolution))
	{
          int rc;
          reenter2:
	  if (instream == 0)
            fprintf (stderr, "Resolution for chip %s: ", chipname (i));
	  rc = fscanf(infile, "%f", &resolutions (i));
	  if (rc != 1) {
		warningmessage
		  ("Invalid value for resolution - please re-enter it.");
		while (nextsymbol() != nl)
		  skipsymbol ();
                goto reenter2;
	  }
	  while (nextsymbol() <= ' ' && nextsymbol() != nl)
	    skipsymbol ();
	  skipsymbol ();
	}
    }

  if (!(strstr (outname, (".JB")) || strstr (outname, (".jb"))))
    strcat (outname, ".jb");
  openoutput (1, outname);
  imp_toupper (outname);
  fprintf (outfile, "SLICE %s,%0d\n", outname, slidecodes (masksize));
  fprintf (outfile, "*\n");
  fprintf (outfile, "* SO %s CREATED  %s USING JBGEN VSN %s.%s AT %s ON %s\n",
	       sonumber, operator, version, release, imp_time (),
	       imp_date ());
  if (mebesjb == 'M')
    {
      fprintf (outfile, "RETICLE\n");
    }
  if (baetitles == true)
    {
      for (i = 1; i <= nummasks; i += 1)
	{
	  fprintf (outfile, "* MTITLE %0d,%s\n", i, titles (i));
	}
      fprintf (outfile, "*\n");
    }
  else if (titlesense != 'N')
    {
      if (strcmp (dtitleline, ""))
	{
	  sprintf (line, "DTITLE A,%s", dtitleline);
	  imp_toupper (line);
	  fprintf (outfile, "%s\n", line);
	}
      for (i = 1; i <= nummasks; i += 1)
	{
	  if (strcmp (titles (i), ""))
	    {
	      fprintf (outfile, "MTITLE %0d,%s\n", i, titles (i));
	    }
	}
      fprintf (outfile, "*\nOPTION ");
      if (mebesjb == 'M')
	{
	  fprintf (outfile, "AA=0.5,SA=100");
	}
      else if (mebesjb == '5')
	{
	  fprintf (outfile, "AA=0.25");
	}
      else
	{
	  fprintf (outfile, "AA=0.5");
	}
      if (datasense == 'I')
	{
	  fprintf (outfile, ",MA");
	}
      if (datasense != titlesense && titlesense != 'N')
	{
	  fprintf (outfile, ",TA");
	}
      fprintf (outfile, "\n");
      if (mebesjb == '5')
	{
	  if (masksize == '5')
	    {
	      fprintf (outfile, "DOSE A,NOMINAL=1,REPEATMAX=5\n");
	    }
	  else
	    {
	      fprintf (outfile, "DOSE A,NOMINAL=10,REPEATMAX=5\n");
	    }
	}
    }
  fprintf (outfile, "*\n");
  if (copy3inch == true || master3inch == true)
    {
      fprintf (outfile, "ORIENT A,DTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=22700,83748,JUST=L\n");
      fprintf (outfile, "ORIENT A,MTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=60200,83748,JUST=L\n");
      fprintf (outfile, "ORIENT A,NTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=20000,16700,JUST=L\n");
      fprintf (outfile, "ORIENT A,PTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=40000,16700,JUST=L\n");
      fprintf (outfile, "ORIENT A,TTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=65000,16700,JUST=L\n");
    }
  else
    switch (masksize)
      {
      case '3':		/* '3' */
	fprintf (outfile, "ORIENT A,DTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=10000,71048,JUST=L\n");
	fprintf (outfile, "ORIENT A,MTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=47500,71048,JUST=L\n");
	fprintf (outfile, "ORIENT A,NTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=33700,4800,JUST=L\n");
	fprintf (outfile, "ORIENT A,PTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=27200,2000,JUST=L\n");
	fprintf (outfile, "ORIENT A,TTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=29200,3400,JUST=L\n");
	break;

      case '4':		/* '4' */
	fprintf (outfile, "ORIENT A,DTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=10000,96448,JUST=L\n");
	fprintf (outfile, "ORIENT A,MTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=60000,96448,JUST=L\n");
	fprintf (outfile, "ORIENT A,NTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=25000,5408,JUST=L\n");
	fprintf (outfile, "ORIENT A,PTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=58040,4000,JUST=L\n");
	fprintf (outfile, "ORIENT A,TTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=25000,4000,JUST=L\n");
	break;
      case '5':		/* '5' */
	fprintf (outfile, "ORIENT A,DTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=18500,119000,JUST=L\n");
	fprintf (outfile, "ORIENT A,MTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=84000,119000,JUST=L\n");
	fprintf (outfile, "ORIENT A,NTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=4000,4000,JUST=L\n");
	fprintf (outfile, "ORIENT A,PTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=103440,2000,JUST=L\n");
	fprintf (outfile, "ORIENT A,TTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=4000,2000,JUST=L\n");
	break;
      case '6':		/* '6' */
	fprintf (outfile, "ORIENT A,DTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=38000,146200,JUST=L\n");
	fprintf (outfile, "ORIENT A,MTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=94400,146200,JUST=L\n");
	fprintf (outfile, "ORIENT A,NTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=5000,4400,JUST=L\n");
	fprintf (outfile, "ORIENT A,PTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=124000,3000,JUST=L\n");
	fprintf (outfile, "ORIENT A,TTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=5000,3000,JUST=L\n");
	break;
      case '7':		/* '7' */
	fprintf (outfile, "ORIENT A,DTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=20000,167600,JUST=L\n");
	fprintf (outfile, "ORIENT A,MTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=130000,167600,JUST=L\n");
	fprintf (outfile, "ORIENT A,NTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=60000,10700,JUST=L\n");
	fprintf (outfile, "ORIENT A,PTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=130000,10700,JUST=L\n");
	fprintf (outfile, "ORIENT A,TTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=20000,10700,JUST=L\n");
	if (mebesjb == 'M')
	  {
	    fprintf (outfile, "* NB: THE N,P,T TITLES CAN NOT BE MOVED DOWNWARDS ON 7 INCH MASKS\n");
	  }
	break;
      case '8':		/* '8' */
	fprintf (outfile, "ORIENT A,DTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=100000,170000,JUST=L\n");
	fprintf (outfile, "ORIENT A,MTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=100000,168500,JUST=L\n");
	fprintf (outfile, "ORIENT A,NTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=55000,167000,JUST=L\n");
	fprintf (outfile, "ORIENT A,PTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=55000,170000,JUST=L\n");
	fprintf (outfile, "ORIENT A,TTITLE,TITLEROT=0,MIRROR=NO,CHARROT=0,LOC=55000,168500,JUST=L\n");
	if (mebesjb == 'M')
	  {
	    fprintf (outfile, "* NB: THE N,P,T TITLES CAN NOT BE MOVED DOWNWARDS ON 7 INCH MASKS\n");
	  }
	break;
      }
  fprintf (outfile, "*\n");
  if (mebesjb != '5' && (!(qualifierpresent ("NOCENT"))))
    generateklamarks ();
  if (baetitles == true)
    {
      fprintf (outfile, "CHIP TIT1,\n");
      for (i = 1; i <= nummasks; i += 1)
	{
	  fprintf (outfile, "$ (%0d,%s-01-00,AD=0.5,SF=1.00)\n", i, titlename (i));
	}
      if (copy3inch == true)
	{
	  fprintf (outfile, "ROWS 22025/50800");
	}
      else
	{
	  fprintf (outfile, "ROWS 9325/50800");
	}
      fprintf (outfile, "\n*\n");
      fprintf (outfile, "CHIP TIT2,\n");
      for (i = 1; i <= nummasks; i += 1)
	{
	  fprintf (outfile, "$ (%0d,%s-02-00,AD=0.5,SF=1.00)\n", i, titlename (i));
	}
      if (copy3inch == true)
	{
	  fprintf (outfile, "ROWS 19525/50800");
	}
      else
	{
	  fprintf (outfile, "ROWS 6825/50800");
	}
      fprintf (outfile, "\n*\n");
      fprintf (outfile, "CHIP BLOGO,\n");
      fprintf (outfile, "$ (AR,BAESYST-LO-GO,AD=0.5,SF=1.00)\n");
      if (copy3inch == true)
	{
	  fprintf (outfile, "ROWS 82075/32700");
	}
      else
	{
	  fprintf (outfile, "ROWS 94775/20000");
	}
      fprintf (outfile, "\n*\n");
    }
  fprintf (outfile, "CHIP MAIN-1,\n");
  for (i = 1; i <= nummasks; i += 1)
    {
      fprintf (outfile, "$ (%0d%s,", i, (reverses (i) == true ? "R" : " "));
      sprintf(line, "%s-%s-%s",
                    substring (chipname (i), 1, 7),
                    substring (chipname (i), 8, 9),
                    substring (chipname (i), 11, 12));
      fprintf (outfile, "%s", line);
      if (globalresolution > minresolution)
	{
	  fprintf (outfile, ",AD=%s)\n", tzdrtos (globalresolution, 0, 10));
	}
      else
	{
	  fprintf (outfile, ",AD=%s)\n", tzdrtos (resolutions (i), 0, 10));
	}
    }

  fprintf (outfile, "ROWS %0d/%0d\n*\n", centers (masksize), centers (masksize));
  if (mebesjb == '5' && (!(qualifierpresent ("NOCENT"))))
    {
      generateklamarks ();
    }
  fprintf (outfile, "END\n");
  closeoutput ();
  exit(0);
  return(0);
}
